/*
 * JBoss, Home of Professional Open Source.
 * Copyright 2009, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags. See the copyright.txt file in the
 * distribution for a full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.jboss.edg.test;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;

import junit.framework.Assert;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpConnectionManager;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.SimpleHttpConnectionManager;
import org.apache.commons.httpclient.methods.ByteArrayRequestEntity;
import org.apache.commons.httpclient.methods.GetMethod;
import org.apache.commons.httpclient.methods.PutMethod;
import org.apache.commons.httpclient.params.HttpConnectionManagerParams;
import org.junit.Test;

public class RestTest {
   @Test
   public void testRest() throws Exception {
      HttpConnectionManager connMgr = new SimpleHttpConnectionManager();
      HttpConnectionManagerParams p = new HttpConnectionManagerParams();
      p.setStaleCheckingEnabled(true);
      p.setSoTimeout(10000);
      p.setConnectionTimeout(10000);
      p.setDefaultMaxConnectionsPerHost(Integer.MAX_VALUE);
      p.setMaxTotalConnections(Integer.MAX_VALUE);
      connMgr.setParams(p);
      HttpClient httpClient = new HttpClient(connMgr);
      PutMethod put = new PutMethod("http://test1:8080/datagrid/rest/___defaultcache/test");
      put.setRequestEntity(new ByteArrayRequestEntity(encodeObject("test"), "application/x-java-serialized-object"));
      Assert.assertEquals(HttpStatus.SC_OK, httpClient.executeMethod(put));
      
      GetMethod get = new GetMethod("http://test1:8080/datagrid/rest/___defaultcache/test");
      get.setRequestHeader("Content-type","text/plain");
      Assert.assertEquals(HttpStatus.SC_OK, httpClient.executeMethod(get));
//      Assert.assertEquals("test", get.getResponseBodyAsString());
   }
   
   private byte[] encodeObject(Object object) throws IOException {
      ByteArrayOutputStream bout = new ByteArrayOutputStream();
      ObjectOutputStream oo = new ObjectOutputStream(bout);
      oo.writeObject(object);
      oo.flush();
      return bout.toByteArray();
   }
}
